Subject: Re: [PATCH 20/31]: pkt_sched: Perform bulk of qdisc destruction in RCU.

From: Patrick McHardy <[email-masked]>
Date: Thu, 17 Jul 2008 16:02:20 +0200

jamal wrote:
> On Thu, 2008-17-07 at 15:03 +0200, Patrick McHardy wrote:
> 
>> Actions are also visible
>> globally, so this might still be a problem, not sure though since
>> they don't refer to their parent (haven't thought about it much yet).
> 
> Actions are fine because they are intended to be globaly shared.
> [i.e A classifier on ethx with qdiscA:Y (in/egress) can share an action
> with  classifer on  ethy with qdiscB:Z (eg/ingress)].

Yes, in that case its not a problem. The case where it behaves
differently than now is when only a single reference exists.

> Like you i need to digest the patches to understand the impact on the
> rest but one thing i did notice was the last patch (replacement of
> pfifo_fast):
> prioritization based on TOS/DSCP (setsockopt) would no longer work, some
> user space code may suffer (routing daemons likely). One suggestion to
> fix it is to load pfifo qdisc (which does what fifo_fast is attempting)
> for drivers that are h/ware multiq capable.

That would perform priorization within each qdisc, the individual
qdiscs would still be transmitted using seperate HW queues though.